Merge tag 'pull-work.namei' of git://git.kernel.org/pub/scm/linux/kernel/git/viro/vfs
[linux-2.6-microblaze.git] / scripts / faddr2line
1 #!/bin/bash
2 # SPDX-License-Identifier: GPL-2.0
3 #
4 # Translate stack dump function offsets.
5 #
6 # addr2line doesn't work with KASLR addresses.  This works similarly to
7 # addr2line, but instead takes the 'func+0x123' format as input:
8 #
9 #   $ ./scripts/faddr2line ~/k/vmlinux meminfo_proc_show+0x5/0x568
10 #   meminfo_proc_show+0x5/0x568:
11 #   meminfo_proc_show at fs/proc/meminfo.c:27
12 #
13 # If the address is part of an inlined function, the full inline call chain is
14 # printed:
15 #
16 #   $ ./scripts/faddr2line ~/k/vmlinux native_write_msr+0x6/0x27
17 #   native_write_msr+0x6/0x27:
18 #   arch_static_branch at arch/x86/include/asm/msr.h:121
19 #    (inlined by) static_key_false at include/linux/jump_label.h:125
20 #    (inlined by) native_write_msr at arch/x86/include/asm/msr.h:125
21 #
22 # The function size after the '/' in the input is optional, but recommended.
23 # It's used to help disambiguate any duplicate symbol names, which can occur
24 # rarely.  If the size is omitted for a duplicate symbol then it's possible for
25 # multiple code sites to be printed:
26 #
27 #   $ ./scripts/faddr2line ~/k/vmlinux raw_ioctl+0x5
28 #   raw_ioctl+0x5/0x20:
29 #   raw_ioctl at drivers/char/raw.c:122
30 #
31 #   raw_ioctl+0x5/0xb1:
32 #   raw_ioctl at net/ipv4/raw.c:876
33 #
34 # Multiple addresses can be specified on a single command line:
35 #
36 #   $ ./scripts/faddr2line ~/k/vmlinux type_show+0x10/45 free_reserved_area+0x90
37 #   type_show+0x10/0x2d:
38 #   type_show at drivers/video/backlight/backlight.c:213
39 #
40 #   free_reserved_area+0x90/0x123:
41 #   free_reserved_area at mm/page_alloc.c:6429 (discriminator 2)
42
43
44 set -o errexit
45 set -o nounset
46
47 usage() {
48         echo "usage: faddr2line [--list] <object file> <func+offset> <func+offset>..." >&2
49         exit 1
50 }
51
52 warn() {
53         echo "$1" >&2
54 }
55
56 die() {
57         echo "ERROR: $1" >&2
58         exit 1
59 }
60
61 READELF="${CROSS_COMPILE:-}readelf"
62 ADDR2LINE="${CROSS_COMPILE:-}addr2line"
63 AWK="awk"
64
65 command -v ${AWK} >/dev/null 2>&1 || die "${AWK} isn't installed"
66 command -v ${READELF} >/dev/null 2>&1 || die "${READELF} isn't installed"
67 command -v ${ADDR2LINE} >/dev/null 2>&1 || die "${ADDR2LINE} isn't installed"
68
69 # Try to figure out the source directory prefix so we can remove it from the
70 # addr2line output.  HACK ALERT: This assumes that start_kernel() is in
71 # init/main.c!  This only works for vmlinux.  Otherwise it falls back to
72 # printing the absolute path.
73 find_dir_prefix() {
74         local objfile=$1
75
76         local start_kernel_addr=$(${READELF} --symbols --wide $objfile | ${AWK} '$8 == "start_kernel" {printf "0x%s", $2}')
77         [[ -z $start_kernel_addr ]] && return
78
79         local file_line=$(${ADDR2LINE} -e $objfile $start_kernel_addr)
80         [[ -z $file_line ]] && return
81
82         local prefix=${file_line%init/main.c:*}
83         if [[ -z $prefix ]] || [[ $prefix = $file_line ]]; then
84                 return
85         fi
86
87         DIR_PREFIX=$prefix
88         return 0
89 }
90
91 __faddr2line() {
92         local objfile=$1
93         local func_addr=$2
94         local dir_prefix=$3
95         local print_warnings=$4
96
97         local sym_name=${func_addr%+*}
98         local func_offset=${func_addr#*+}
99         func_offset=${func_offset%/*}
100         local user_size=
101         local file_type
102         local is_vmlinux=0
103         [[ $func_addr =~ "/" ]] && user_size=${func_addr#*/}
104
105         if [[ -z $sym_name ]] || [[ -z $func_offset ]] || [[ $sym_name = $func_addr ]]; then
106                 warn "bad func+offset $func_addr"
107                 DONE=1
108                 return
109         fi
110
111         # vmlinux uses absolute addresses in the section table rather than
112         # section offsets.
113         local file_type=$(${READELF} --file-header $objfile |
114                 ${AWK} '$1 == "Type:" { print $2; exit }')
115         [[ $file_type = "EXEC" ]] && is_vmlinux=1
116
117         # Go through each of the object's symbols which match the func name.
118         # In rare cases there might be duplicates, in which case we print all
119         # matches.
120         while read line; do
121                 local fields=($line)
122                 local sym_addr=0x${fields[1]}
123                 local sym_elf_size=${fields[2]}
124                 local sym_sec=${fields[6]}
125                 local sec_size
126                 local sec_name
127
128                 # Get the section size:
129                 sec_size=$(${READELF} --section-headers --wide $objfile |
130                         sed 's/\[ /\[/' |
131                         ${AWK} -v sec=$sym_sec '$1 == "[" sec "]" { print "0x" $6; exit }')
132
133                 if [[ -z $sec_size ]]; then
134                         warn "bad section size: section: $sym_sec"
135                         DONE=1
136                         return
137                 fi
138
139                 # Get the section name:
140                 sec_name=$(${READELF} --section-headers --wide $objfile |
141                         sed 's/\[ /\[/' |
142                         ${AWK} -v sec=$sym_sec '$1 == "[" sec "]" { print $2; exit }')
143
144                 if [[ -z $sec_name ]]; then
145                         warn "bad section name: section: $sym_sec"
146                         DONE=1
147                         return
148                 fi
149
150                 # Calculate the symbol size.
151                 #
152                 # Unfortunately we can't use the ELF size, because kallsyms
153                 # also includes the padding bytes in its size calculation.  For
154                 # kallsyms, the size calculation is the distance between the
155                 # symbol and the next symbol in a sorted list.
156                 local sym_size
157                 local cur_sym_addr
158                 local found=0
159                 while read line; do
160                         local fields=($line)
161                         cur_sym_addr=0x${fields[1]}
162                         local cur_sym_elf_size=${fields[2]}
163                         local cur_sym_name=${fields[7]:-}
164
165                         if [[ $cur_sym_addr = $sym_addr ]] &&
166                            [[ $cur_sym_elf_size = $sym_elf_size ]] &&
167                            [[ $cur_sym_name = $sym_name ]]; then
168                                 found=1
169                                 continue
170                         fi
171
172                         if [[ $found = 1 ]]; then
173                                 sym_size=$(($cur_sym_addr - $sym_addr))
174                                 [[ $sym_size -lt $sym_elf_size ]] && continue;
175                                 found=2
176                                 break
177                         fi
178                 done < <(${READELF} --symbols --wide $objfile | ${AWK} -v sec=$sym_sec '$7 == sec' | sort --key=2)
179
180                 if [[ $found = 0 ]]; then
181                         warn "can't find symbol: sym_name: $sym_name sym_sec: $sym_sec sym_addr: $sym_addr sym_elf_size: $sym_elf_size"
182                         DONE=1
183                         return
184                 fi
185
186                 # If nothing was found after the symbol, assume it's the last
187                 # symbol in the section.
188                 [[ $found = 1 ]] && sym_size=$(($sec_size - $sym_addr))
189
190                 if [[ -z $sym_size ]] || [[ $sym_size -le 0 ]]; then
191                         warn "bad symbol size: sym_addr: $sym_addr cur_sym_addr: $cur_sym_addr"
192                         DONE=1
193                         return
194                 fi
195
196                 sym_size=0x$(printf %x $sym_size)
197
198                 # Calculate the address from user-supplied offset:
199                 local addr=$(($sym_addr + $func_offset))
200                 if [[ -z $addr ]] || [[ $addr = 0 ]]; then
201                         warn "bad address: $sym_addr + $func_offset"
202                         DONE=1
203                         return
204                 fi
205                 addr=0x$(printf %x $addr)
206
207                 # If the user provided a size, make sure it matches the symbol's size:
208                 if [[ -n $user_size ]] && [[ $user_size -ne $sym_size ]]; then
209                         [[ $print_warnings = 1 ]] &&
210                                 echo "skipping $sym_name address at $addr due to size mismatch ($user_size != $sym_size)"
211                         continue;
212                 fi
213
214                 # Make sure the provided offset is within the symbol's range:
215                 if [[ $func_offset -gt $sym_size ]]; then
216                         [[ $print_warnings = 1 ]] &&
217                                 echo "skipping $sym_name address at $addr due to size mismatch ($func_offset > $sym_size)"
218                         continue
219                 fi
220
221                 # In case of duplicates or multiple addresses specified on the
222                 # cmdline, separate multiple entries with a blank line:
223                 [[ $FIRST = 0 ]] && echo
224                 FIRST=0
225
226                 echo "$sym_name+$func_offset/$sym_size:"
227
228                 # Pass section address to addr2line and strip absolute paths
229                 # from the output:
230                 local args="--functions --pretty-print --inlines --exe=$objfile"
231                 [[ $is_vmlinux = 0 ]] && args="$args --section=$sec_name"
232                 local output=$(${ADDR2LINE} $args $addr | sed "s; $dir_prefix\(\./\)*; ;")
233                 [[ -z $output ]] && continue
234
235                 # Default output (non --list):
236                 if [[ $LIST = 0 ]]; then
237                         echo "$output" | while read -r line
238                         do
239                                 echo $line
240                         done
241                         DONE=1;
242                         continue
243                 fi
244
245                 # For --list, show each line with its corresponding source code:
246                 echo "$output" | while read -r line
247                 do
248                         echo
249                         echo $line
250                         n=$(echo $line | sed 's/.*:\([0-9]\+\).*/\1/g')
251                         n1=$[$n-5]
252                         n2=$[$n+5]
253                         f=$(echo $line | sed 's/.*at \(.\+\):.*/\1/g')
254                         ${AWK} 'NR>=strtonum("'$n1'") && NR<=strtonum("'$n2'") { if (NR=='$n') printf(">%d<", NR); else printf(" %d ", NR); printf("\t%s\n", $0)}' $f
255                 done
256
257                 DONE=1
258
259         done < <(${READELF} --symbols --wide $objfile | ${AWK} -v fn=$sym_name '$4 == "FUNC" && $8 == fn')
260 }
261
262 [[ $# -lt 2 ]] && usage
263
264 objfile=$1
265
266 LIST=0
267 [[ "$objfile" == "--list" ]] && LIST=1 && shift && objfile=$1
268
269 [[ ! -f $objfile ]] && die "can't find objfile $objfile"
270 shift
271
272 DIR_PREFIX=supercalifragilisticexpialidocious
273 find_dir_prefix $objfile
274
275 FIRST=1
276 while [[ $# -gt 0 ]]; do
277         func_addr=$1
278         shift
279
280         # print any matches found
281         DONE=0
282         __faddr2line $objfile $func_addr $DIR_PREFIX 0
283
284         # if no match was found, print warnings
285         if [[ $DONE = 0 ]]; then
286                 __faddr2line $objfile $func_addr $DIR_PREFIX 1
287                 warn "no match for $func_addr"
288         fi
289 done